/*
 * WeinRegisterVariant.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "WEINBUS/WeinbusRegisterVariant.h"

namespace WEINBUS
{
//CONSTRUCTOR
WeinbusRegisterVariant::WeinbusRegisterVariant():
        t(WEINBUS::DATA_UINT32),
        u32((uint32_t)0)
{}//CONSTRUCTOR


WEINBUS::data_variant_type_t WeinbusRegisterVariant::get_type() const
{
    return t;
    //
}//
//
void WeinbusRegisterVariant::set_uint16(uint16_t value)
{
    u16 = value;
    t = WEINBUS::DATA_UINT16;
    //
}//
//
void WeinbusRegisterVariant::set_int16(int16_t value)
{
    i16 = value;
    t = WEINBUS::DATA_INT16;
    //
}//
//
void WeinbusRegisterVariant::set_uint32(uint32_t value)
{
    u32 = value;
    t = WEINBUS::DATA_UINT32;
    //
}//
//
void WeinbusRegisterVariant::set_int32(int32_t value)
{
    i32 = value;
    t = WEINBUS::DATA_INT32;
    //
}//
//
void WeinbusRegisterVariant::set_float(float value)
{
    f = value;
    t = WEINBUS::DATA_FLOAT;
    //
}//
//
uint16_t WeinbusRegisterVariant::get_uint16() const
{
    return u16;
    //
}//
//
int16_t WeinbusRegisterVariant::get_int16() const
{
    return i16;
    //
}//
//
uint32_t WeinbusRegisterVariant::get_uint32() const
{
    return u32;
    //
}//
//
int32_t  WeinbusRegisterVariant::get_int32() const
{
    return i32;
    //
}//
//
float WeinbusRegisterVariant::get_float() const
{
    return f;
    //
}//
//
} /* namespace WEINBUS */
